/**
 * Prikaz osnovnih operacija sa jednostruko povezanom listom - formiranje i
 * stampanje
 */
public class ListeOsnovneOperacije {

	public static void main(String[] arg) {
		ListaBrojeva lista = new ListaBrojeva();
		System.out.println("unesite n (broj brojeva): ");
		int n = Svetovid.in.readInt();
		System.out.println("unesite brojeve");
		for (int i = 0; i < n; i++) {
			double br = Svetovid.in.readDouble();
			lista.dodajNaPocetak(br);
		}
		System.out.println("Sadrzaj liste:");
		lista.stampajNaEkran();
	}
}

/**
 * ListaBrojeva predstavlja listu brojeva sa odgovarajucim operacijama za
 * dodavanje u listu i za stampanje iste.
 */
class ListaBrojeva {

	/**
	 * Element u klasi ListaBrojeva. Sadrzi informaciju, odnosno broj i
	 * pokazivac na sledeci element u listi.
	 * 
	 * Klasa je napravljena kao unutrasnja od ListaBrojeva posto zapravo nikog
	 * van klase i ne treba da interesuje kako iznutra predstavljamo podatke.
	 * 
	 * Klasa je mogla biti postavljena i na istom nivou kao ListaBrojeva i bila
	 * bi ista funkcionalnost.
	 */
	class Element {
		double info;
		Element veza;

		public Element(double br) {
			this.info = br;
			this.veza = null;
		}

		public String toString() {
			return info + "";
		}
	}

	// pokazivac na prvi element liste
	Element prvi;

	/** Kreira praznu listu brojeva. */
	public ListaBrojeva() {
		this.prvi = null;
	}

	/** Dodaje novi broj na pocetak liste */
	public void dodajNaPocetak(double br) {
		Element novi = new Element(br);
		novi.veza = prvi;
		prvi = novi;
	}

	/** Vraca da li je lista prazna */
	public boolean jePrazna() {
		return prvi == null;
	}

	public void stampajNaEkran() {
		if (jePrazna()) {
			Svetovid.out.println("Lista je prazna");
		} else {
			Svetovid.out.println("Sadrzaj liste:");
			Element tekuci = prvi;
			while (tekuci != null) {
				System.out.println(tekuci.info);
				tekuci = tekuci.veza;
			}
			System.out.println();
		}
	}

	public String toString() {
		String rez = "Lista: [ ";
		Element tekuci = prvi;
		while (tekuci != null) {
			rez += tekuci.info + " ";
			tekuci = tekuci.veza;
		}
		rez += "]";
		return rez;
	}

}
