public class Fib {

	/**
	 * Originalna funkcija koja će biti simulirana
	 */
	static int fibR(int n) {
		if (n <= 1)
			return n;
		else
			return fibR(n - 1) + fibR(n - 2);
	}

	private static class InfoTip {
		int n, prviSab, adr;
	}

	/**
	 * Simulirana verzija rekurzivne funkcije
	 */
	static int fibS(int n) {
		int prviSab, rez;
		InfoTip el;
		Stek<InfoTip> s = new Stek<InfoTip>(100);
		
		do {
			// rekurzivni spust
			while (n > 1) {
				el = new InfoTip();
				el.n = n;
				el.adr = 1;
				s.stavi(el);
				n = n - 1;
			}
			
			// trivijalni slucaj
			rez = n;
			
			// povratak iz rekurzije
			boolean nemaPoziva = true;
			while (!s.jePrazan() && nemaPoziva) {
				el = s.skiniVrh();
				n = el.n;
				if (el.adr == 1) {
					prviSab = rez;
					el.n = n;
					el.adr = 2;
					el.prviSab = prviSab;
					s.stavi(el);
					n = n - 2;
					nemaPoziva = false;
				} else {
					prviSab = el.prviSab;
					rez = prviSab + rez;
				}
			}
			
		} while (!s.jePrazan());
		return rez;
	}

	public static void main(String[] args) {
		int n = Svetovid.in.readInt("n = ?");
		System.out.print("F(n) = ");
		System.out.print(fibR(n));
		System.out.print(" = ");
		System.out.println(fibS(n));
	}
}