/**
 * Kompleksniji primer u kome simuliramo funkciju cije funkcionisanje
 * i rezultat nisu nuzno jasni.
 * 
 * U funkciji postoje ugnjezdjeni pozivi na koje treba obratiti paznju.
 * 
 * Ova verzija resenja takodje sadrzi i ispise parametara na 'ulazu' u
 * funkciju, i iste takve kod simulirane verzije da se jasno vidi da se
 * svi pozivi desavaju u istom redosledu, pri cemu su dodatno naznacene
 * adrese poziva u simuliranoj verziji. Ovakav dodatak nije potreban inace
 * za resavanje, ali moze pomoci u razumevanju i proveri da li je
 * sve ispravno uradjeno.
 */
public class Rek2 {

	static int g(int x, int y, int n) {
		System.out.printf("0 %d %d %d\n",x,y,n);
		if (n < 3) {
			return x + y;
		}

		if (n % 2 == 1) {
			return g(g(x + 1, y, n - 2), y, n - 3);
		} else {
			return g(x, g(x, y + 1, n - 2), n - 3);
		}
	}

	private static class InfoTip {
		int x, y, n, adr;
	}

	static int gS(int x, int y, int n) {
		int rez;
		InfoTip el;
		Stek<InfoTip> s = new Stek<InfoTip>();
		System.out.printf("%d %d %d %d\n",0,x,y,n);

		do {
			// rekurzivni spust
			while (n >= 3) {
				if (n % 2 == 1) {
					el = new InfoTip();
					el.x = x;
					el.y = y;
					el.n = n;
					el.adr = 1;
					s.stavi(el);
					x = x + 1;
					n = n - 2;
					System.out.printf("%d %d %d %d\n",el.adr,x,y,n);
				} else {
					el = new InfoTip();
					el.x = x;
					el.y = y;
					el.n = n;
					el.adr = 3;
					s.stavi(el);
					y = y + 1;
					n = n - 2;
					System.out.printf("%d %d %d %d\n",el.adr,x,y,n);
				}
			}

			// trivijalni slucaj
			rez = x + y;

			// povratak iz rekurzije
			boolean nemaPoziva = true;
			while (!s.jePrazan() && nemaPoziva) {
				el = s.skiniVrh();
				x = el.x;
				y = el.y;
				n = el.n;
				if (el.adr == 1) {
					el.x = x; // nije potrebno zapravo
					el.y = y; // nije potrebno zapravo
					el.n = n; // nije potrebno zapravo
					el.adr = 2;
					s.stavi(el);
					x = rez;
					n = n - 3;
					System.out.printf("%d %d %d %d\n",el.adr,x,y,n);
					nemaPoziva = false;
				} else if (el.adr == 3) {
					el.x = x; // nije potrebno zapravo
					el.y = y; // nije potrebno zapravo
					el.n = n; // nije potrebno zapravo
					el.adr = 4;
					s.stavi(el);
					y = rez;
					n = n - 3;
					System.out.printf("%d %d %d %d\n",el.adr,x,y,n);
					nemaPoziva = false;
				} // adr 2 i 4
				  // rez = rez; nema smisla pisati
			}
		} while (!s.jePrazan());
		return rez;
	}

	public static void main(String[] args) {
		System.out.println(g(2, 3, 11));
		System.out.println(gS(2, 3, 11));
	}
}
