public class Stepenovanje {

	static double kvadrat(double y) {
		return y * y;
	}

	/**
	 * Originalna funkcija koja će biti simulirana
	 */
	static double naStepenR(double x, int n) {
		if (n <= 0)
			return 1;
		else if (n % 2 != 0)
			return x * kvadrat(naStepenR(x, n / 2));
		else
			return kvadrat(naStepenR(x, n / 2));
	}

	private static class InfoTip {
		double x;
		int n;
		int adr;
	}

	/**
	 * Simulirana verzija rekurzivne funkcije
	 */
	static double naStepenS(double x, int n) {
		InfoTip el;
		Stek<InfoTip> s = new Stek<InfoTip>(100);
		
		// rekurzivni silaz
		while (n > 0) {
			if (n % 2 != 0) {
				el = new InfoTip();
				el.x = x;
				el.n = n;
				el.adr = 1;
				s.stavi(el);
			} else {
				el = new InfoTip();
				el.x = x;
				el.n = n;
				el.adr = 2;
				s.stavi(el);
			}
			n = n / 2;
		}
		
		// trivijalni slucaj
		double rez = 1.0;
		
		// povratak iz rekurzije
		while (!s.jePrazan()) {
			el = s.skiniVrh();
			x = el.x;
			n = el.n;
			if (el.adr == 1)
				rez = x * kvadrat(rez);
			else
				rez = kvadrat(rez);
		}
		return rez;
	}

	public static void main(String[] args) {
		System.out.print("x = ");
		double x = Svetovid.in.readDouble();
		System.out.print("n = ");
		int n = Svetovid.in.readInt();
		System.out.print("x^n = ");
		System.out.print(naStepenR(x, n));
		System.out.print(" = ");
		System.out.println(naStepenS(x, n));
	}
}